<?php
namespace Teknisa\CRM\Service;


class EvolucaoService
{
    protected $evolucaoFactory;
    
    public function __construct ($evolucaoFactory){
        
        $this->evolucaoFactory   = $evolucaoFactory;
    }
    
    public function callForGetNrDiasLanceEvol($paramsSelectNrDiasLanceEvol){
        $nrDiasLanceEvol = $this->evolucaoFactory->requestForGetNrDiasLanceEvol($paramsSelectNrDiasLanceEvol);
        
        return $nrDiasLanceEvol;
    }
    
    public function getAttachment($nrorg, $nrseqevolcont, $numberOfFiles){
        $attaches = $this->evolucaoFactory->getLastAttachments($nrorg, $nrseqevolcont, $numberOfFiles);
        $attachesToSend = array();
        $index = 0;
        foreach ($attaches as $attach) {
            $attachesToSend[$index] = array(
                    "path" => $attach['DSCAMINHO'],
                    "name" => $attach['NMARQUIVO'],
                    "type" => $attach['DSTIPO']
                );
            $index++;
        }
        return $attachesToSend;
    }
}
?>