<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 30/08/13
 * Time: 14:15
 * To change this template use File | Settings | File Templates.
 */

namespace Teknisa\CRM\Util;

use \Teknisa\Libs\Util\SMTP;


/*require_once 'Zend/Mail.php';
require_once 'Zend/Mail/Transport/Smtp.php';*/


class Mail {

    private $_mailConfig;

    public function __construct($crmParameters, $sendEmail = false) {
        $this->CRMParameters = $crmParameters;
        if($sendEmail){
            $this->smtpParams = $this->CRMParameters->returnParamsSmtp();
            $this->smtpService = new SMTP($this->smtpParams);
        }
/*
        $this->_mailConfig = new Config($to, $subject, $content);

        try {

            // Definindo os parâmetros de configuração do SMTP
            $config = array (
                'auth' => $this->_mailConfig->getAuth(),
                'username' => $this->_mailConfig->getUsername(),
                'password' => $this->_mailConfig->getPassword()
            );

            // Enviando o email
            $mailTransport = new \Zend_Mail_Transport_Smtp($this->_mailConfig->getServer(), $config);
            \Zend_Mail::setDefaultTransport($mailTransport);
            $mail = new \Zend_Mail();
            $mail->setFrom($this->_mailConfig->getFrom());
            $mail->addTo($this->_mailConfig->getTo());
            $mail->setBodyHtml(utf8_decode($this->_mailConfig->getContent()), null, 'UTF-8'); // Conteúdo no formato HTML
            //$mail->setBodyText(utf8_decode($this->_mailConfig->getContent())); // Conteúdo no formato texto padrão
            $mail->setSubject(utf8_decode($this->_mailConfig->getSubject()));
            $mail->send($mailTransport);

            return true;

        } catch (\Exception $e){

            return false;
//            $error = 'Ops! Não foi possível enviar o email, informe ao administrador o seguinte erro: ' . $e->getMessage();

        }*/

    }
    public function newEmail($email, $subject, $message, $from = null, $attachments = null, $toName = null, $emailCC = null, $nameCC = null){
        
        $this->smtpService->setSubject($subject);
        if(!is_null($from)){
            $this->smtpService->setFromName($from);
        }
        if(!is_null($toName)){
            $this->smtpService->setNmAddress($toName);
        }
        if(!is_null($nameCC)){
            $this->smtpService->setNameCC($nameCC);
        }
        if(!is_null($attachments)){
            $unlink = array();
            foreach($attachments as $attachment){
                $link = 'https://midia.teknisa.com/files/'.$attachment["path"];
                $dir = sys_get_temp_dir().DIRECTORY_SEPARATOR.uniqid().'.'.$attachment["type"];
                array_push($unlink, $dir);
                file_put_contents($dir, file_get_contents($link));
                $this->smtpService->addAttachment($dir, $attachment['name'].'.'.$attachment["type"], 'base64', $attachment["type"]);
            }
        }
        $this->smtpService->sendMail($message, $email, $emailCC);
        //Remove os diretórios temporários
        if(!is_null($attachments)){
            foreach ($unlink as $dir) {
                unlink($dir);
            }
        }
            
    }
    /**
     * Processa a requisição de uma nova senha
     * @param string $nmacesso
     * @param string $nrorg
     * @author rodrigomarques
     * @deprecated
     */

//    public static function processNewPassword($nmacesso, $nrorg) {
//        $newPassword = self::getNewPassword();
//        $mailOper = Mercadum_Model_Operador::getEmailOper($nmacesso, $nrorg);
//        if(is_null($mailOper)) {
//            throw new Exception(UNKNOWN_MAIL_OPER);
//        }
//        $subject = 'Requisicao de senha';
//        $bodyText = "Sua nova senha: $newPassword";
//        Mercadum_Model_Operador::updatePassword($nmacesso, $nrorg, $newPassword);
//        // Mercadum_Util::sendMail($mailOper, $subject, $bodyText);
//    }

    /**
     * Retorna uma senha aleatória de 10 dígitos
     * @return integer
     * @author rodrigomarques
     */
    public static function getNewPassword() {
        $password =  rand(0,9).chr(rand(ord("a"), ord("z"))).
            rand(0,9).chr(rand(ord("A"), ord("Z"))).
            rand(0,9).chr(rand(ord("a"), ord("z")));

        return $password;
    }

    /**
     * Criptografa a senha do operador
     * @param string $cdsenhoper
     * @return string
     * @author rodrigomarques
     */
    public static function encrypts($cdsenhoper) {
        return sha1($cdsenhoper);
    }

}